/* eslint-disable prettier/prettier */
import { SlashCommand, SlashCreator, CommandOptionType, CommandContext } from 'slash-create';

export default class StockCommand extends SlashCommand {
  constructor(creator: SlashCreator) {
    super(creator, {
      name: 'stock',
      description: 'checks stock price',
      options: [{ type: CommandOptionType.STRING, name: 'ticker', description: 'the ticker to check', required: true }]
    });
  }

  async run(ctx: CommandContext) {
    const tkr = ctx.options.ticker
    const req = await fetch(`https://www.alphavantage.co/query?function=GLOBAL_QUOTE&symbol=${tkr}&apikey=${process.env.ALPHAVANTAGE_KEY}`)
    const info = await req.json()
    if (Object.keys(info['Global Quote']).length == 0) {
      return `stock not found!`
    }
    const i = info['Global Quote']
    return `stock info for ${i['01. symbol']} - OPEN: ${i['02. open']} - PRICE: ${i['05. price']} - % CHANGE: ${i['10. change percent']}`
  }
}
